
#include "zeus.h"

char *civage( civ )
int civ;
{
	int index;
	for( index = 4; index >= 0; index-- )
	{
		if( ( Civ[ civ ].astpos + Civ[ civ ].astnew )
			>= Civ[ civ ].AST[ index ] )
			return( Ages[ index + 1 ] );
	}
	return( Ages[ 0 ] );
}

get_years()
{
	FILE *fileptr;
	char line[ 128 ];
	char *word[ 65 ];
	int index, civ, nast;

	if( !( fileptr= fopen( YEARSFILE, "r" ) ) )
		fopen_error( YEARSFILE );

	while( fgetline( fileptr, line, 128 ) != -1 )
	{
		index = 0;
		word[ index++ ] = strtok( line, " :," );
		while( ( word[ index ] = strtok( NULL, " :," ) ) ) index++;

		Years[ atoi( word[ 0 ] ) ] = atoi( word[ 1 ] );
	}

	fclose( fileptr );
}

get_ast()
{
	FILE *fileptr;
	char line[ 128 ];
	char *word[ 65 ];
	int index, civ, nast;

	if( !( fileptr= fopen( ASTTEMPLATE, "r" ) ) )
		fopen_error( ASTTEMPLATE );

	while( fgetline( fileptr, line, 128 ) != -1 )
	{
		index = 0;
		word[ index++ ] = strtok( line, " -:," );
		while( ( word[ index ] = strtok( NULL, " -:," ) ) ) index++;

		civ = civ_to_num( word[ 0 ] );

		if( civ == -1 )
			continue;

		Civ[ civ ].AST[ 0 ] = atoi( word[ 1 ] );
		Civ[ civ ].AST[ 1 ] = atoi( word[ 2 ] );
		Civ[ civ ].AST[ 2 ] = atoi( word[ 3 ] );
		Civ[ civ ].AST[ 3 ] = atoi( word[ 4 ] );
		Civ[ civ ].AST[ 4 ] = atoi( word[ 5 ] );

		for( nast = 0; nast < AST_SIZE - Civ[ civ ].AST[ 4 ] + 1; nast++ )
			Civ[ civ ].AST[ nast + 5 ] = atoi( word[ nast + 6 ] );
	}

	fclose( fileptr );
}

list_ast( mode )
int mode;
{
	char command[ 128 ];

	if( mode )
	{
		send_file( ASTFILE, "ast", sender );
	}
	else
	{
		sprintf( command, "cat %s >> %s", ASTFILE, TEMPFILE );
		system( command );
	}
}

int ast_advance( civ )
int civ;
{
	int index, age, advance;
	int groups[ 5 ], ngroups, ntechs;

	advance = 1;
	ngroups = 0;
	ntechs = 0;
	for( index = 0; index < 5; index++ )
		groups[ index ] = 0;

	for( index = 4; index >= 0; index-- )
	{
		if( ( Civ[ civ ].astpos + 1 ) >= Civ[ civ ].AST[ index ] )
		{
			age = index;
			break;
		}
	}

	/* move backwards if no cities and at least one required */
	if( !Civ[ civ ].cities && ( CitiesRequired[ age ] > 0 ) )
	{
		advance = -1;
		return( advance );
	}

	/* test for city requirement */
	if( Civ[ civ ].cities < CitiesRequired[ age ] )
	{
		advance = 0;
		return( advance );
	}

	/* count number of cards */
	for( index = 0; index < NUM_TECHS; index++ )
		if( Civ[ civ ].tech[ index ] )
			ntechs++;

	/* count all cards per group */
	for( index = 0; index < NUM_TECHS; index++ )
	{
		if( Civ[ civ ].tech[ index ] )
		{
			groups[ Tech[ index ].subtype1 ]++;
			groups[ Tech[ index ].subtype2 ]++;
		}
	}

	/* count groups */
	for( index = 0; index < 5; index++ )
		if( groups[ index ] )
			ngroups++;

	switch ( age )
	{
		/* stone age */
		case 0:
			break;

		/* early bronze */
		case 1:
			break;

		/* late bronze */
		case 2:
			if( ngroups < 3 )
				advance = 0;
			break;

		/* early iron */
		case 3:
			if( ngroups < 5 )
				advance = 0;
			if( ntechs < 9 )
				advance = 0;
			break;

		/* late iron */
		case 4:
			if( total_civcard_points( civ ) <
				( Civ[ civ ].AST[ Civ[ civ ].astpos + 1 -
					Civ[ civ ].AST[ 4 ] + 5 ] * 10 ) )
				advance = 0;
			break;
	}

	return( advance );
}

create_AST_file( filename, turn )
char *filename;
int turn;
{
	FILE *fileptr;
	int civ, pos, ast;

	if( !( fileptr = fopen( filename, "w+" ) ) )
		fopen_error( filename );

	fprintf( fileptr, "AST - Turn %2d\n", turn );
	fprintf( fileptr, "=============\n\n" );
	fprintf( fileptr,
"           1   2   3   4   5   6   7   8   9   10  11  12  13  14  15  16\n" );
	for( civ = 0; civ < NumCivs; civ++ )
	{
		if( Civ[ civ ].active != 1 )
			continue;
		fprintf( fileptr,
"............................................................................\n" );
		fprintf( fileptr, "%-9s", Civ[ civ ].name );
		for( pos = Civ[ civ ].AST[ 0 ]; pos < Civ[ civ ].AST[ 1 ]; pos++ )
			fprintf( fileptr, " sss" );
		for( pos = Civ[ civ ].AST[ 1 ]; pos < Civ[ civ ].AST[ 2 ]; pos++ )
			fprintf( fileptr, " bbb" );
		for( pos = Civ[ civ ].AST[ 2 ]; pos < Civ[ civ ].AST[ 3 ]; pos++ )
			fprintf( fileptr, " BBB" );
		for( pos = Civ[ civ ].AST[ 3 ]; pos < Civ[ civ ].AST[ 4 ]; pos++ )
			fprintf( fileptr, " iii" );
		for( pos = Civ[ civ ].AST[ 4 ]; pos <= AST_SIZE; pos++ )
			fprintf( fileptr, " %3d",
				Civ[ civ ].AST[ pos - Civ[ civ ].AST[ 4 ] + 5 ] );
		fprintf( fileptr, "\n" );
		ast = Civ[ civ ].astpos + Civ[ civ ].astnew - 1;
		if( ast != -1 )
		{
			fprintf( fileptr, "         " );
			for( pos = 0; pos < ast; pos++ )
				fprintf( fileptr, "    " );
			fprintf( fileptr, " XXX\n" );
		}
		else
		{
			fprintf( fileptr, "\n" );
		}
	}
	fprintf( fileptr,
"............................................................................\n" );
	fprintf( fileptr, "\n" );
	fprintf( fileptr,
"sss = stone age\n" );
	fprintf( fileptr,
"bbb = early bronze age (2 cities)\n" );
	fprintf( fileptr,
"BBB = late bronze age  (3 cities, 3 different card groups)\n" );
	fprintf( fileptr,
"iii = early iron age   (4 cities, 9 cards, all 5 card groups)\n" );
	fprintf( fileptr,
"  # = late iron age    (5 cities, #*10 points in civilization cards)\n" );

	fclose( fileptr );
}

get_ast_positions()
{
	FILE *fileptr;
	char line[ 128 ];
	char *word[ 65 ];
	int index;

	if( !( fileptr = fopen( ASTPOSFILE, "r" ) ) )
		fopen_error( ASTPOSFILE );

	while( fgetline( fileptr, line, 128 ) != -1 )
	{
		index = 0;
		word[ index++ ] = strtok( line, " -:," );
		while( ( word[ index ] = strtok( NULL, " -:," ) ) ) index++;

		Civ[ civ_to_num( word[ 0 ] ) ].astpos = atoi( word[ 1 ] );
	}

	fclose( fileptr );
}

int next_age( civ )
int civ;
{
	int index;
	for( index = 0; index < 5; index++ )
	{
		if( ( Civ[ civ ].astpos + Civ[ civ ].astnew ) ==
			( Civ[ civ ].AST[ index ] - 1 ) )
			return( 1 );
	}
	return( 0 );
}
