
#include "zeus.h"

handle_volcanic_eruption( civ )
int civ;
{
	int area;
	int volcano;

	volcano = 0;
	for( area = 0; area < NumAreas; area++ )
	{
		if( Map[ area ].city == civ )
		{
			printf( "%s: volcano site: %s\n",
				Civ[ civ ].abbr, Map[ area ].name );
			volcano++;
		}
	}
	if( !volcano )
	{
		if( Civ[ civ ].eng )
			printf( "%s: earthquake reduces 1 city\n",
				Civ[ civ ].abbr );
		else
			printf( "%s: earthquake eliminates 1 city\n",
				Civ[ civ ].abbr );
	}
	else
		printf( "%s: volcano eliminates all adjacent units\n",
			Civ[ civ ].abbr );
}

handle_treachery( civ )
int civ;
{
}

handle_civil_war( civ )
int civ;
{
	int city;
	int units;

	if( Civ[ civ ].phi )
		units = 15;
	else
	{
		units = 35;
		if( Civ[ civ ].mus )
			units += 5;
		if( Civ[ civ ].dap )
			units += 5;
		if( Civ[ civ ].dem )
			units += 10;
	}
	printf( "    keeps %d units\n", units );
	printf( "    " );
	for( city = 0; city < Civ[ civ ].cities; city++ )
		printf( "%s ", Map[ Civ[ civ ].city_elim[ city ] ].name );
	printf( "\n" );

	{
		/*
		int area_info[ MAX_AREAS ];
		int area;

		for( area = 0; area < NumAreas; area++ )
			area_info[ area ] = 0;
		find_areas( civ, area_info, 2 );
		list_areas( area_info );
		*/

		/*
		for( area = 0; area < NumAreas; area++ )
			area_info[ area ] = 0;
		find_areas( civ, area_info, 1 );
		list_areas( area_info );
		*/
	}
}

handle_flood( civ )
int civ;
{
	int plain[ MAX_FLOODS ];
	int index, area, flood, city;

	for( index = 0; index < MAX_FLOODS; index++ )
		plain[ index ] = 0;

	for( area = 0; area < NumAreas; area++ )
	{
		if( ( Map[ area ].flood > 0 ) )
		{
			if( Map[ area ].city == ( civ + 1 ) )
				plain[ Map[ area ].flood - 1 ] += 5;
			else
				plain[ Map[ area ].flood - 1 ] += Map[ area ].tokens[ civ ];
		}
	}

	flood = 0;
	for( index = 0; index < MAX_FLOODS; index++ )
	{
		if( plain[ index ] > 5 )
		{
			flood = index + 1;
			printf( "    flood plain %d: %d units\n",
				index + 1, plain[ index ] );
		}
	}

	if( flood > 0 )
	{
		if( Civ[ civ ].eng )
			printf( "    7 units eliminated\n" );
		else
			printf( "    17 units eliminated\n" );
		printf( "    " );
		for( city = 0; city < Civ[ civ ].cities; city++ )
		{
			if( ( Map[ Civ[ civ ].city_elim[ city ] ].flood == flood ) &&
				( Map[ Civ[ civ ].city_elim[ city ] ].site == 2 ) )
					printf( "%s ", Map[ Civ[ civ ].city_elim[ city ] ].name );
		}
		printf( "\n" );
	}
	else
	{
		if( Civ[ civ ].eng )
		{
			printf( "    1 coastal city reduced\n" );
			printf( "    " );
			for( city = 0; city < Civ[ civ ].cities; city++ )
			{
				if( Map[ Civ[ civ ].city_reduce[ city ] ].geo == COAST )
					printf( "%s ", Map[ Civ[ civ ].city_reduce[ city ] ].name );
			}
			printf( "\n" );
		}
		else
		{
			printf( "    1 coastal city eliminated\n" );
			printf( "    " );
			for( city = 0; city < Civ[ civ ].cities; city++ )
			{
				if( Map[ Civ[ civ ].city_elim[ city ] ].geo == COAST )
					printf( "%s ", Map[ Civ[ civ ].city_elim[ city ] ].name );
			}
			printf( "\n" );
		}
	}
}

handle_civil_disorder( civ )
int civ;
{
	int city;
	int cities = 3;

	if( Civ[ civ ].mus )
		cities++;
	if( Civ[ civ ].dap )
		cities++;
	if( Civ[ civ ].law )
		cities++;
	if( Civ[ civ ].dem )
		cities++;
	if( Civ[ civ ].mil )
		cities--;
	if( Civ[ civ ].roa )
		cities--;
	printf( "    all but %d cities reduced\n", cities );
	printf( "    " );
	for( city = 0; city < Civ[ civ ].cities; city++ )
		printf( "%s ", Map[ Civ[ civ ].city_reduce[ city ] ].name );
	printf( "\n" );
}

handle_iconoclasm_heresy( civ )
int civ;
{
	int city;
	int cities = 4;

	if( Civ[ civ ].law )
		cities--;
	if( Civ[ civ ].phi )
		cities--;
	if( Civ[ civ ].the )
		cities -= 3;
	if( Civ[ civ ].mon )
		cities++;
	if( Civ[ civ ].roa )
		cities++;
	printf( "    %d cities reduced\n", cities );
	printf( "    " );
	for( city = 0; city < Civ[ civ ].cities; city++ )
		printf( "%s ", Map[ Civ[ civ ].city_reduce[ city ] ].name );
	printf( "\n" );
}

get_city_lists()
{
	FILE *fileptr;
	char line[ 128 ];
	char *word[ 65 ];
	int index, civ, card, curciv, city, area;
	int listsread;

	if( !( fileptr = fopen( LISTSFILE, "r" ) ) )
		fopen_error( LISTSFILE );

	curciv = -1;
	while( fgetline( fileptr, line, 128 ) != -1 )
	{
		index = 0;
		word[ index++ ] = strtok( line, " :,-" );
		while( ( word[ index ] = strtok( NULL, " :,-" ) ) ) index++;

		if( !word[ 0 ] )
			continue;
		
		civ = civ_to_num( word[ 0 ] );
		if( civ != -1 )
		{
			if( !mail )
			{
				if( curciv != -1 )
				{
					if( listsread == 2 )
						printf( "done\n" );
					else
						printf( "\n" );
				}
				printf( "%s...", Civ[ civ ].name );
			}
			for( city = 0; city < MaxCities; city++ )
			{
				Civ[ civ ].city_reduce[ city ] = -1;
				Civ[ civ ].city_elim[ city ] = -1;
			}
			curciv = civ;
			listsread = 0;
		}
		else if( !strcmp( word[ 0 ], "r" ) )
		{
			if( ( index - 1 ) != Civ[ curciv ].cities )
			{
				fprintf( returnfile, "%s has %d cities, list has %d\n",
					Civ[ curciv ].name, Civ[ curciv ].cities, index - 1 );
				zeus_exit( "bad city list" );
			}
			for( city = 1; city < index; city++ )
			{
				area = area_to_num( word[ city ] );
				if( area == -1 )
					zeus_exit( "bad city list" );
				if( Map[ area ].city != ( curciv + 1 ) )
				{
					fprintf( returnfile, "%s has no city in %s\n",
						Civ[ curciv ].name, Map[ area ].name );
					zeus_exit( "bad city list" );
				}
				Civ[ curciv ].city_reduce[ city - 1 ] = area;
			}
			listsread++;
		}
		else if( !strcmp( word[ 0 ], "e" ) )
		{
			if( ( index - 1 ) != Civ[ curciv ].cities )
			{
				fprintf( returnfile, "%s has %d cities, list has %d\n",
					Civ[ curciv ].name, Civ[ curciv ].cities, index - 1 );
				zeus_exit( "bad city list" );
			}
			for( city = 1; city < index; city++ )
			{
				area = area_to_num( word[ city ] );
				if( area == -1 )
					zeus_exit( "bad city list" );
				if( Map[ area ].city != ( curciv + 1 ) )
				{
					fprintf( returnfile, "%s has no city in %s\n",
						Civ[ curciv ].name, Map[ area ].name );
					zeus_exit( "bad city list" );
				}
				Civ[ curciv ].city_elim[ city - 1 ] = area;
			}
			listsread++;
		}
	}
	if( !mail )
	{
		if( curciv != -1 )
		{
			if( listsread == 2 )
				printf( "done\n" );
			else
				printf( "\n" );
		}
	}
}

handle_fate()
{
	char line[ 128 ];
	int civ, card, ncal;

	handle_deal();

	for( civ = 0; civ < NumCivs; civ++ )
		get_hand( civ, 0 );

	ncal = 0;
	for( card = 0; card < NTCards; card++ )
		if( Card[ card ].cal )
			for( civ = 0; civ < NumCivs; civ++ )
				if( Civ[ civ ].cards[ card ] )
				{
					printf( "%d %-20s %s\n\n",
						ncal + 1, Card[ card ].name, Civ[ civ ].name );
					if( !strcmp( Card[ card ].abbr, "VOL" ) )
					{
						handle_volcanic_eruption( civ );
					}
					else if( !strcmp( Card[ card ].abbr, "TRE" ) )
					{
						handle_treachery( civ );
					}
					else if( !strcmp( Card[ card ].abbr, "WAR" ) )
					{
						handle_civil_war( civ );
					}
					else if( !strcmp( Card[ card ].abbr, "FLO" ) )
					{
						handle_flood( civ );
					}
					else if( !strcmp( Card[ card ].abbr, "DIS" ) )
					{
						handle_civil_disorder( civ );
					}
					else if( !strcmp( Card[ card ].abbr, "ICO" ) )
					{
						handle_iconoclasm_heresy( civ );
					}
					printf( "\n" );
					ncal++;
				}
}

handle_calamities()
{
	FILE *fileptr, *output;
	char filename[ 128 ];

	handle_deal();

	CalamityOccured = 0;

	sprintf( filename, "%d/%02d04", Turn, Turn );
	output = fopen( filename, "w+" );

	fprintf( output, "Turn %2d - Calamity Summary\n", Turn );

	if( !( fileptr = fopen( CALAMITIESFILE, "r" ) ) )
		fopen_error( CALAMITIESFILE );
	resolve_calamities( fileptr, output );
	fclose( fileptr );

	if( !CalamityOccured )
		fprintf( output, "\nNo Calamities\n" );

	fprintf( output, "\n" );
	print_mapboard( output, 5, 0 );
	fclose( output );

	if( !( fileptr = fopen( MAPBOARD5, "w+" ) ) )
		fopen_error( MAPBOARD5 );
	print_mapboard( fileptr, 5, 0 );
	fclose( fileptr );
}
