
#include "zeus.h"

init_decks( output )
FILE *output;
{
	int newdeck[ NUM_DECKS ][ MAX_CARDS ];
	int deck, card;
	int calam;
	int cards[ 2 ];
	int ncards[ 2 ];
	int totalcards;
	int numbers[ 32 ];
	int index;
	int type;

	for( deck = 0; deck < NUM_DECKS; deck++ )
	{
		for( card = 0; card < MaxCards[ deck ]; card++ )
			newdeck[ deck ][ card ] = -1;
	}

	for( deck = 0; deck < NUM_DECKS; deck++ )
	{
		type = 0;
		calam = -1;
		for( card = 0; card < NTCards; card++ )
		{
			if( Card[ card ].deck == deck )
			{
				if( !Card[ card ].tradeable )
				{
					newdeck[ deck ][ MaxCards[ deck ] - 1 ] = card;
				}
				else if( Card[ card ].cal )
				{
					calam = card;
				}
				else
				{
					cards[ type ] = card;
					ncards[ type ] = Card[ card ].number;
					type++;
				}
			}
		}
		card = 0;
		totalcards = Card[ cards[ 0 ] ].number + Card[ cards[ 1 ] ].number;
		get_numbers( totalcards, numbers );
		for( index = 0; index < NumPlayers; index++ )
		{
			if( numbers[ index ] < Card[ cards[ 0 ] ].number )
			{
				newdeck[ deck ][ card ] = cards[ 0 ];
				ncards[ 0 ]--;
			}
			else
			{
				newdeck[ deck ][ card ] = cards[ 1 ];
				ncards[ 1 ]--;
			}
			card++;
		}

		if( calam >= 0 )
			totalcards = ncards[ 0 ] + ncards[ 1 ] + 1;
		else
			totalcards = ncards[ 0 ] + ncards[ 1 ];
		get_numbers( totalcards, numbers );
		for( index = 0; index < totalcards; index++ )
		{
			if( ( calam >= 0 ) && ( numbers[ index ] == totalcards - 1 ) )
			{
				newdeck[ deck ][ card ] = calam;
			}
			else if( numbers[ index ] < ncards[ 0 ] )
			{
				newdeck[ deck ][ card ] = cards[ 0 ];
			}
			else
			{
				newdeck[ deck ][ card ] = cards[ 1 ];
			}
			card++;
		}
	}
	for( deck = 0; deck < NUM_DECKS; deck++ )
	{
		fprintf(output,"Deck %d\n===========\n",deck+1);
		for( card = 0; card < MaxCards[ deck ]; card++ )
			fprintf(output,"%s\n",Card[ newdeck[deck][card] ].abbr);
		fprintf(output,"\n");
	}
}

int card_to_num( name )
char *name;
{
	int card;
	for( card = 0; card < NTCards; card++ )
		if( !strcasecmp( Card[ card ].abbr, name ) )
			return( card );
	for( card = 0; card < NTCards; card++ )
		if( !strcasecmp( Card[ card ].name, name ) )
			return( card );
	return( -1 );
}

int civcardtype_to_num( type )
char *type;
{
	if( !strcmp( type, "craft" ) )
		return( CRAFT );
	else if( !strcmp( type, "science" ) )
		return( SCIENCE );
	else if( !strcmp( type, "art" ) )
		return( ART );
	else if( !strcmp( type, "civic" ) )
		return( CIVIC );
	else if( !strcmp( type, "religion" ) )
		return( RELIGION );
	else
		return( OTHER );
}

list_cards( mode )
int mode;
{
	char command[ 128 ];
	char title[ 128 ];

	if( mode )
	{
		sprintf( title, "%s's cards", Civ[ logged_in ].name );
		send_file( CARDSFILE( Civ[ logged_in ].abbr ), title, sender );
	}
	else
	{
		sprintf( command,
			"cat %s >> %s", CARDSFILE( Civ[ logged_in ].abbr ), TEMPFILE );
		system( command );
	}
}

print_calamity_locations( tempfile )
FILE *tempfile;
{
	int deck, card;

	fprintf( tempfile, "\n---Calamity Locations\n" );
	for( card = 0; card < 12; card++ )
	{
		int newcards;
		fprintf( tempfile, "%d.%-20s",
				Card[ card + 18 ].deck + 1, Card[ card + 18 ].name );

		newcards = OldNumCards[ Card[ card + 18 ].deck ] -
			NumCards[ Card[ card + 18 ].deck ];

		CalamityLocation[ card ][ 0 ] -= newcards;
		CalamityLocation[ card ][ 1 ] -= newcards;
		if( CalamityLocation[ card ][ 0 ] < 0 )
			CalamityLocation[ card ][ 0 ] = 0;
		if( CalamityLocation[ card ][ 1 ] < 0 )
			CalamityLocation[ card ][ 1 ] = 0;

		if( ( CalamityLocation[ card ][ 0 ] == 0 ) &&
			( CalamityLocation[ card ][ 1 ] == 0 ) )
			fprintf( tempfile, " *" );
		else if( CalamityLocation[ card ][ 0 ] == 0 )
			fprintf( tempfile, " *" );
		else if( ( CalamityLocation[ card ][ 0 ] <= NumPlayers ) &&
			( CalamityLocation[ card ][ 1 ] <= NumPlayers ) )
			fprintf( tempfile, " !" );
		else if( CalamityLocation[ card ][ 0 ] <= NumPlayers ) 
			fprintf( tempfile, " ?" );
		else
			fprintf( tempfile, "  " );

		if( ( CalamityLocation[ card ][ 0 ] == 0 ) &&
			( CalamityLocation[ card ][ 1 ] == 0 ) )
			fprintf( tempfile, " IN PLAY\n" );
		else if( CalamityLocation[ card ][ 0 ] ==
			CalamityLocation[ card ][ 1 ] )
			fprintf( tempfile, " %2d\n",
				CalamityLocation[ card ][ 0 ] );
		else
			fprintf( tempfile, " %2d %2d\n",
				CalamityLocation[ card ][ 0 ],
				CalamityLocation[ card ][ 1 ] );
	}
}

list_cardcount( mode )
int mode;
{
	int deck, civ, totalcards, card;

	if( mode )
		tempfile = fopen( TEMPFILE, "w+" );
	else
		tempfile = fopen( TEMPFILE, "a" );
	if( !tempfile )
		fopen_error( TEMPFILE );

	totalcards = 0;

	for( deck = 0; deck < NUM_DECKS; deck++ )
	{
		fprintf( tempfile, "Deck %d    : %2d / %2d (",
			deck + 1, NumCards[ deck ], MaxCards[ deck ] );
		for( card = 0; card < NTCards; card++ )
		{
			if( Card[ card ].deck == deck )
			{
				if( Card[ card ].number > 1 )
					fprintf( tempfile, " %d-%s", Card[ card ].number,
						Card[ card ].abbr );
				else
					fprintf( tempfile, " %s", Card[ card ].abbr );
			}
		}
		fprintf( tempfile, " )\n" );
		totalcards += NumCards[ deck ];
	}
	fprintf( tempfile, "---\n" );

	for( civ = 0; civ < NumCivs; civ++ )
	{
		if( Civ[ civ ].active == 0 )
			continue;
		get_hand( civ, 0 );
		fprintf( tempfile, "%-10s: %2d\n",
			Civ[ civ ].name, Civ[ civ ].ncards );
		totalcards += Civ[ civ ].ncards;
	}
	fprintf( tempfile, "---\n" );
	fprintf( tempfile, "%-10s:%3d\n",
		"Total", totalcards );

	if( ShowCalamities )
		print_calamity_locations( tempfile );

	fclose( tempfile );

	if( mode )
		send_file( TEMPFILE, "cardcount", sender );
}

create_calamity_locations_file()
{
	FILE *fileptr;
	int card;

	if( !( fileptr = fopen( CALLOCFILE, "w" ) ) )
		fopen_error( CALLOCFILE );

	for( card = 0; card < NTCards; card++ )
	{
		if( Card[ card ].cal )
		{
			if( !Card[ card ].tradeable )
			{
				fprintf( fileptr, "%s%3d%3d%3d\n", Card[ card ].abbr,
					NumCards[ Card[ card ].deck ],
					NumCards[ Card[ card ].deck ],
					NumCards[ Card[ card ].deck ] );
			}
			else
			{
				fprintf( fileptr, "%s%3d%3d%3d\n", Card[ card ].abbr,
					NumPlayers + 1,
					NumCards[ Card[ card ].deck ],
					NumCards[ Card[ card ].deck ] );
			}
		}
	}
	fclose( fileptr );
}

get_calamity_locations()
{
	FILE *fileptr;
	char line[ 128 ];
	char *word[ 65 ];
	int index;
	int card;

	if( !( fileptr = fopen( CALLOCFILE, "r" ) ) )
		return;

	while( fgetline( fileptr, line, 128 ) != -1 )
	{
		index = 0;
		word[ index++ ] = strtok( line, " -:," );
		while( ( word[ index ] = strtok( NULL, " -:," ) ) ) index++;

		card = card_to_num( word[ 0 ] );
		CalamityLocation[ card - 18 ][ 0 ] = atoi( word[ 1 ] );
		CalamityLocation[ card - 18 ][ 1 ] = atoi( word[ 2 ] );
		OldNumCards[ Card[ card ].deck ] = atoi( word[ 3 ] );
	}

	fclose( fileptr );
}

get_decks( flag )
int flag;
{
	FILE *cardfile;
	char line[ 128 ];
	char *word[ 65 ];
	int index;
	int deck, card, ctype, odeck;

	if( flag == 0 )
	{
		if( !( cardfile = fopen( DECKSFILE, "r" ) ) )
			fopen_error( DECKSFILE );
	}
	else
	{
		if( !( cardfile = fopen( NEWDECKSFILE, "r" ) ) )
		{
			if( !( cardfile = fopen( DECKSFILE, "r" ) ) )
				fopen_error( DECKSFILE );
		}
	}


	for( deck = 0; deck < NUM_DECKS; deck++ )
		for( card = 0; card < MAX_CARDS; card++ )
			Deck[ deck ][ card ] = -1;

	odeck = -1;
	while( fgetline( cardfile, line, 128 ) != -1 )
	{
		for( ctype = 0; ctype < NTCards; ctype++ )
		{
			if( !strcmp( line, Card[ ctype ].abbr ) )
			{
				if( Card[ ctype ].deck != odeck )
					card = 0;
				Deck[ Card[ ctype ].deck ][ card ] = ctype;
				card++;
				NumCards[ Card[ ctype ].deck ] = card;
				odeck = Card[ ctype ].deck;
				/*
				if( Card[ ctype ].cal && !Card[ ctype ].tradeable )
				{
					CalamityLocation[ ctype - 18 ][ 0 ] = card;
					CalamityLocation[ ctype - 18 ][ 1 ] = card;
				}
				*/
			}
		}
	}
	fclose( cardfile );

	get_calamity_locations();
}

shuffle_discards()
{
	FILE *fileptr, *calloc;
	int civ;
	int deck, card, ctype, ncards;
	int discards[ NUM_DECKS ][ MAX_CARDS ];
	int ndiscards[ NUM_DECKS ];
	int random[ NUM_DECKS][ MAX_CARDS ];
	int number, index;

	get_decks( 1 );

	for( card = 0; card < 12; card++ )
	{
		int newcards;

		newcards = OldNumCards[ Card[ card + 18 ].deck ] -
			NumCards[ Card[ card + 18 ].deck ];

		CalamityLocation[ card ][ 0 ] -= newcards;
		CalamityLocation[ card ][ 1 ] -= newcards;
		if( CalamityLocation[ card ][ 0 ] <= 0 )
			CalamityLocation[ card ][ 0 ] = 1;
		if( CalamityLocation[ card ][ 1 ] <= 0 )
			CalamityLocation[ card ][ 1 ] = 1;
	}

	/* initialize arrays */
	for( deck = 0; deck < NUM_DECKS; deck++ )
	{
		for( card = 0; card < MAX_CARDS; card++ )
		{
			discards[ deck ][ card ] = -1;
			random[ deck ][ card ] = -1;
		}
		ndiscards[ deck ] = 0;
	}

	/* put cards in discard piles */
	for( civ = 0; civ < NumCivs; civ++ )
	{
		for( ctype = 0; ctype < NTCards; ctype++ )
		{
			if( !Card[ ctype ].tradeable )
				continue;
			ncards = Civ[ civ ].discards[ ctype ];
			if( ncards > 0 )
			{
				/*
				deck = Card[ ctype ].deck - 1;
				*/
				deck = Card[ ctype ].deck;
				for( card = 0; card < ncards; card++ )
				{
					discards[ deck ][ ndiscards[ deck ] ] = ctype;
					ndiscards[ deck ]++;
				}
			}
		}
	}

	/* shuffle the tradeable cards */
	for( deck = 0; deck < NUM_DECKS; deck++ )
		get_numbers( ndiscards[ deck ], random[ deck ] );

	if( !( fileptr = fopen( LASTDECKSFILE, "w+" ) ) )
		fopen_error( LASTDECKSFILE );
	for( deck = 0; deck < NUM_DECKS; deck++ )
	{
		fprintf( fileptr, "Deck %d\n===========\n", deck + 1 );

		/* write out existing cards */
		for( card = 0; card < NumCards[ deck ]; card++ )
		{
			/*
			if( Deck[ deck ][ card ] != -1 )
				fprintf( fileptr, "%s\n", Card[ Deck[ deck ][ card ] ].abbr );
			*/
			fprintf( fileptr, "%s\n", Card[ Deck[ deck ][ card ] ].abbr );
		}
		fprintf( fileptr, "---\n" );

		/* put tradeable cards back in decks */
		for( index = 0; index < ndiscards[ deck ]; index++ )
		{
			number = random[ deck ][ index ];
			fprintf( fileptr, "%s\n", Card[ discards[ deck ][ number ] ].abbr );
			NumCards[ deck ]++;
			/* update calamity locations */
			if( Card[ discards[ deck ][ number ] ].cal )
			{
				CalamityLocation[ discards[ deck ][ number ] - 18 ][ 0 ] =
					card + 1;
				CalamityLocation[ discards[ deck ][ number ] - 18 ][ 1 ] =
					card + ndiscards[ deck ];
			}
		}

		/* return non-tradeable cards to bottom of deck */
		for( civ = 0; civ < NumCivs; civ++ )
		{
			for( ctype = 0; ctype < NTCards; ctype++ )
			{
				if( !Card[ ctype ].tradeable && Civ[ civ ].discards[ ctype ] )
				{
					if( Card[ ctype ].deck == deck )
					{
						fprintf( fileptr, "%s\n", Card[ ctype ].abbr );
						NumCards[ deck ]++;
						CalamityLocation[ ctype - 18 ][ 0 ] = NumCards[ deck ];
						CalamityLocation[ ctype - 18 ][ 1 ] = NumCards[ deck ];
					}
				}
			}
		}

		fprintf( fileptr, "\n" );
	}
	fclose( fileptr );

	/* update calamity locations */
	if( !( calloc = fopen( CALLOCNEWFILE, "w+" ) ) )
		fopen_error( CALLOCNEWFILE );
	for( index = 0; index < 12; index++ )
	{
		fprintf( calloc, "%s %d %d %d\n",
			Card[ index + 18 ].abbr,
			CalamityLocation[ index ][ 0 ],
			CalamityLocation[ index ][ 1 ],
			NumCards[ Card[ index + 18 ].deck ] );
	}
	fclose( calloc );
}

get_cards()
{
	FILE *fileptr;
	char line[ 128 ];
	char *word[ 65 ];
	int index;
	int deck, card, ctype, odeck;

	if( !( fileptr = fopen( TRADECARDSFILE, "r" ) ) )
		fopen_error( TRADECARDSFILE );

	while( fgetline( fileptr, line, 128 ) != -1 )
	{
		index = 0;
		word[ index++ ] = strtok( line, " -:," );
		while( ( word[ index ] = strtok( NULL, " -:," ) ) ) index++;

		Card[ NTCards ].name = (char *)malloc( strlen( word[ 0 ] ) + 1 );
		strcpy( Card[ NTCards ].name, word[ 0 ] );
		Card[ NTCards ].abbr = (char *)malloc( strlen( word[ 1 ] ) + 1 );
		strcpy( Card[ NTCards ].abbr, word[ 1 ] );
		Card[ NTCards ].deck = atoi( word[ 2 ] ) - 1;
		Card[ NTCards ].number = atoi( word[ 3 ] );
		Card[ NTCards ].tradeable = atoi( word[ 4 ] );
		Card[ NTCards ].cal = atoi( word[ 5 ] );
		Card[ NTCards ].mine = atoi( word[ 6 ] );
		MaxCards[ Card[ NTCards ].deck ] += Card[ NTCards ].number;
		NTCards++;
	}
	fclose( fileptr );
}

handle_newdeal()
{
	char command[ 128 ];

	sprintf( command, "/bin/rm %s", NEWDECKSFILE );
	system( command );
	handle_deal();
}

handle_deal()
{
	FILE *boardfile;
	FILE *sumfile;
	char command[ 128 ];
	FILE *goldfile;
	FILE *output;
	char filename[ 128 ];
	char line[ 128 ];
	int eligible[ 2 * MAX_CIVS ];
	int num_eligible;
	int deck, civ, cities, card, cardsleft;
	int numbers[ 32 ];
	int cardsweredealt = 0;

	handle_cities();

	if( ( output = fopen( NEWDECKSFILE, "r" ) ) )
		cardsweredealt = 1;

	for( civ = 0; civ < NumCivs; civ++ )
	{
		Civ[ civ ].buygold = 0;
		Civ[ civ ].ndraws = 0;
		get_hand( civ, 0 );
	}

	if( !( goldfile = fopen( GOLDFILE, "r" ) ) )
		fopen_error( GOLDFILE );
	if( !mail )
		printf( "\nexecuting gold orders...\n\n" );
	modify_mapboard( goldfile, NULL );
	fclose( goldfile );

	for( deck = 0; deck < NUM_DECKS; deck++ )
	{
		for( num_eligible = 0; num_eligible < NumCivs; num_eligible++ )
			eligible[ num_eligible ] = 0;
		num_eligible = 0;
		cardsleft = NumCards[ deck ];
		for( cities = 0; cities <= MaxCities; cities++ )
		{
			for( civ = 0; civ < NumCivs; civ++ )
			{
				if( ( Civ[ civ ].active == 1 ) && cardsleft &&
					( Civ[ civ ].cities > deck ) &&
					( Civ[ civ ].cities == cities ) )
				{
					eligible[ num_eligible++ ] = civ;
					cardsleft--;
					if( !cardsweredealt )
						Civ[ civ ].ncards++;
				}
				if( ( Civ[ civ ].active == 1 ) && cardsleft &&
					Civ[ civ ].buygold &&
					( Civ[ civ ].treasury >= 18 ) &&
					( deck == 8 ) &&
					( Civ[ civ ].cities == cities ) )
				{
					eligible[ num_eligible++ ] = civ;
					cardsleft--;
					Civ[ civ ].treasury -= 18;
					Civ[ civ ].stock += 18;
					if( !cardsweredealt )
						Civ[ civ ].ncards++;
					Civ[ civ ].buygold = 2;
				}
			}
		}
		get_numbers( num_eligible, numbers );
		for( civ = 0; civ < num_eligible; civ++ )
		{
			Civ[ eligible[ civ ] ].newcards[ Civ[ eligible[ civ ] ].ndraws++ ] =
				Deck[ deck ][ numbers[ civ ] ];
			Deck[ deck ][ numbers[ civ ] ] = -1;
		}
	}

	if( !cardsweredealt )
	{
		if( !( output = fopen( DEALFILE, "w+" ) ) )
			fopen_error( DEALFILE );

		fprintf( output, "\nDeal\n----\n" );
		for( civ = 0; civ < NumCivs; civ++ )
		{
			if( ( Civ[ civ ].active == 1 ) && Civ[ civ ].ndraws )
			{
				fprintf( output, "\n***%-15s", Civ[ civ ].name );

				fprintf( output, "\nhnd: " );
				for( card = 0; card < NTCards; card++ )
					if( Civ[ civ ].cards[ card ] == 1 )
						fprintf( output, "%3s ",
							Card[ card ].abbr );
					else if( Civ[ civ ].cards[ card ] > 1 )
						fprintf( output, "%1d-%3s ",
							Civ[ civ ].cards[ card ], Card[ card ].abbr );

				fprintf( output, "\n---\ndrw:" );
				for( card = 0; card < Civ[ civ ].ndraws; card++ )
				{
					Civ[ civ ].cards[ Civ[ civ ].newcards[ card ] ]++;
					fprintf( output, "%4s",
						Card[ Civ[ civ ].newcards[ card ] ].abbr );
				}

				fprintf( output, "\nhnd: " );
				for( card = 0; card < NTCards; card++ )
					if( Civ[ civ ].cards[ card ] == 1 )
						fprintf( output, "%3s ", Card[ card ].abbr );
					else if( Civ[ civ ].cards[ card ] > 1 )
						fprintf( output, "%1d-%3s ",
							Civ[ civ ].cards[ card ], Card[ card ].abbr );

				fprintf( output, "\ntre: %d", Civ[ civ ].treasury );

				fprintf( output, "\n--- %d\n", total_in_hand( civ ) );
			}
		}
		fclose( output );
	
		if( !( output = fopen( NEWDECKSFILE, "w+" ) ) )
			fopen_error( NEWDECKSFILE );

		for( deck = 0; deck < NUM_DECKS; deck++ )
		{
			fprintf( output, "Deck %d\n===========\n", deck + 1 );
			for( card = 0; card < MaxCards[ deck ]; card++ )
			{
				if( Deck[ deck ][ card ] != -1 )
					fprintf( output, "%s\n", Card[ Deck[ deck ][ card ] ].abbr );
			}
			fprintf( output, "\n" );
		}
		fclose( output );
	
		if( !( output = fopen( NEWCARDSFILE, "w+" ) ) )
			fopen_error( NEWCARDSFILE );

		fprintf( output, "Trade Cards\n===========\n\n" );
		fprintf( output, "Civilization    # Cards   Gold   New Draws \n" );
		fprintf( output, "------------    -------   ----   -------------------\n" );
		for( civ = 0; civ < NumCivs; civ++ )
		{
			if( Civ[ civ ].active == 1 )
			{
				fprintf( output, "%-12s    %7d    ",
					Civ[ civ ].name, Civ[ civ ].ncards );
	
				if( ( Civ[ civ ].buygold == 2 ) )
					fprintf( output, "yes  " );
				else
					fprintf( output, " no  " );
	
				for( card = 0; card < Civ[ civ ].ndraws; card++ )
					fprintf( output, " %d",
						Card[ Civ[ civ ].newcards[ card ] ].deck + 1 );
	
				fprintf( output, "\n" );
			}
		}
		fprintf( output, "\nMapboard\n========\n\n" );
		for( civ = 0; civ < NumCivs; civ++ )
		{
			if( Civ[ civ ].active == 1 )
			{
				fprintf( output, "%-12s", Civ[ civ ].name );
				fprintf( output, "* %d cities : ", Civ[ civ ].cities );
				fprintf( output, "%d census : ", Civ[ civ ].census );
				fprintf( output, "%d treasury : ", Civ[ civ ].treasury );
				fprintf( output, "%d stock\n", Civ[ civ ].stock );
			}
		}
		fclose( output );
	}

	boardfile = fopen( MAPBOARD4, "w+" );
	print_mapboard( boardfile, 4, 0 );
	fclose( boardfile );

	sprintf( filename, "%d/%02d02", Turn, Turn );
	sumfile = fopen( filename, "w+" );
	fprintf( sumfile, "Turn %2d - City Summary\n\n", Turn );
	fclose( sumfile );

	sprintf( command, "cat %s >> %d/%02d02", CITIESFILE, Turn, Turn );
	system( command );

	sumfile = fopen( filename, "a" );
	fprintf( sumfile, "\n" );
	fclose( sumfile );

	sprintf( command, "cat %s >> %d/%02d02", MAPBOARD3, Turn, Turn );
	system( command );

	sumfile = fopen( filename, "a" );
	fprintf( sumfile, "\n" );
	fclose( sumfile );

	sprintf( command, "cat %s >> %d/%02d02", NEWCARDSFILE, Turn, Turn );
	system( command );
}

get_hand( civ, initialhand )
int civ;
int initialhand;
{
	FILE *cardfile;
	char filename[ 128 ];
	char line[ 128 ], sline[ 128 ];
	char *word[ 65 ];
	int nline;
	int index;
	char hand[ 128 ];
	int nwrd;
	int card, number;

	if( Civ[ civ ].active == 0 )
		return;

	if( !( cardfile = fopen( CARDSFILE( Civ[ civ ].abbr ), "r" ) ) )
		fopen_error( CARDSFILE( Civ[ civ ].abbr ) );

	Civ[ civ ].ncards = 0;
	for( card = 0; card < NTCards; card++ )
	{
		Civ[ civ ].cards[ card ]  = 0;
		Civ[ civ ].discards[ card ] = 0;
	}

	nline = 0;
	while( fgetline( cardfile, line, 128 ) != -1 )
	{
		strcpy( sline, line );
		nline++;

		index = 0;
		word[ index++ ] = strtok( line, " -:," );
		while( ( word[ index ] = strtok( NULL, " -:," ) ) ) index++;

		if( !word[ 0 ] )
			continue;
		
		if( !strcmp( word[ 0 ], "hnd" ) )
		{
			strcpy( hand, sline );
			if( initialhand == 1 )
				break;
		}
		else if( !strcmp( word[ 0 ], "tre" ) )
			Civ[ civ ].treasury = atoi( word[ 1 ] );	
	}

	index = 0;
	word[ index++ ] = strtok( hand, " -:," );
	while( ( word[ index ] = strtok( NULL, " -:," ) ) ) index++;

	number = 1;
	for( nwrd = 1; nwrd < index; nwrd++ )
	{
		card = card_to_num( word[ nwrd ] );
		if( card == -1 )
		{
			number = atoi( word[ nwrd ] );
		}
		else
		{
			Civ[ civ ].cards[ card ] += number;
			Civ[ civ ].ncards += number;
			number = 1;
		}
	}
	fclose( cardfile );
}

int total_in_hand( civ )
int civ;
{
	int card;
	int value;

	value = Civ[ civ ].treasury;
	for( card = 0; card < NTCards; card++ )
		if( !Card[ card ].cal )
			value += ( Civ[ civ ].cards[ card ] * Civ[ civ ].cards[ card ] *
				( Card[ card ].deck + 1 ) );
	return( value );
}
