
#include "zeus.h"

read_mail( input )
FILE *input;
{
	char line[128], sline[128];
	char *word[ 65 ];
	int nline, index, civ, prop, nwrd, card;
	char command[ 128 ];
	int propose;
	int signed_on;

	if( !( maillog = fopen( MAILLOGFILE, "a+" ) ) )
		fopen_error( MAILLOGFILE );

	nline = 0;
	logged_in = -1;
	signed_on = 0;
	propose = 0;
	if( mail )
		fprintf( maillog, "*** BEGIN MESSAGE ***\n" );
	if( !mail )
		printf( "<mail> " );
	while( fgetline( input, line, 128 ) != -1 )
	{
		if( mail )
		{
			fprintf( maillog, "%s\n", line );
			fprintf( returnfile, "%s\n", line );
		}

		strcpy( sline, line );

		nline++;
		index = 0;
		word[ index++ ] = strtok( line, " -:," );
		while( ( word[ index ] = strtok( NULL, " -:," ) ) ) index++;

		if( !word[ 0 ] )
		{
		}
		else if( logged_in == -1 )
		{
			if( !strcmp( word[ 0 ], "signon" ) && ( index == 3 ) )
			{
				civ = civ_to_num( word[ 1 ] );
				if( civ == -1 )
				{
					fprintf( returnfile,
						">>> \"%s\" is an unknown civilization\n", word[ 1 ] );
					zeus_exit( "signon error" );
				}
				if( strcmp( Civ[ civ ].password, word[ 2 ] ) )
				{
					fprintf( returnfile, ">>> wrong password\n" );
					zeus_exit( "signon error" );
				}
				logged_in = civ;
				signed_on = 1;
				strcpy( sender, Civ[ logged_in ].name );
			}
			else if( !strcmp( word[ 0 ], "From" ) )
			{
				strcpy( sender, word[ 1 ] );
			}
		}
		else if( logged_in >= 0 )
		{
			if( !strcasecmp( word[ 0 ], "replyto" ) )
			{
				char command[ 128 ];
				strcpy( sender, word[ 1 ] );
				sprintf( command,
"echo \'replyto %s\' was issued from your signon | Mail -s \"zeus: replyto\" %s",
	word[ 1 ], Civ[ logged_in ].name );
				system( command );
			}
			else if( !strcmp( word[ 0 ], "exit" ) )
			{
				logged_in = -1;
				if( !mail )
					break;
			}
			else if( !strcmp( word[ 0 ], "cancel" ) &&
				!strcmp( word[ 1 ], "proposal" ) && ( index == 3 ) )
			{
				cancel_proposal( word[ 2 ] );
				list_proposals( logged_in );
			}
			else if( !strcmp( word[ 0 ], "help" ) )
			{
				help();
			}
			else if( !strcmp( word[ 0 ], "ships" ) )
			{
				get_mapboard();
				if( !( tempfile = fopen( TEMPFILE, "w+" ) ) )
					fopen_error( TEMPFILE );
				handle_civships( input, tempfile );
				fclose( tempfile );
				send_file( TEMPFILE, "ship results", sender );
			}
			else if( !strcmp( word[ 0 ], "checkmove" ) )
			{
				/*
				get_mapboard();
				handle_move();
				*/
				get_latest_mapboard();
				if( Civ[ logged_in ].moved )
				{
					fprintf( returnfile,
						">>> you have already moved this turn\n" );
					zeus_exit( "movement error" );
				}
				if( !( tempfile = fopen( TEMPFILE, "w+" ) ) )
					fopen_error( TEMPFILE );
				get_moves( input, tempfile );
				fprintf( tempfile, "\n" );
				print_mapboard( tempfile, 1, 0 );
				fclose( tempfile );
				send_file( TEMPFILE, "movement results", sender );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "help" ) )
			{
				help();
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "areas" ) )
			{
				int area_info[ MAX_AREAS ];
				int count;
				/*
				get_mapboard();
				*/
				get_latest_mapboard();
				for( count = 0; count < MAX_AREAS; count++ )
					area_info[ count ] = 1;
				list_areas( area_info );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "rules" ) )
			{
				list_rules();
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "status" ) )
			{
				list_status();
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "credits" ) )
			{
				list_credits();
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "calamities" ) )
			{
				list_calamities();
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "trades" ) )
			{
				list_trades( 1 );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "cards" ) )
			{
				list_cards( 1 );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "proposals" ) )
			{
				list_proposals( logged_in );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "cardcount" ) )
			{
				list_cardcount( 1 );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "tradecards" ) )
			{
				list_cardcount( 1 );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "cardcosts" ) )
			{
				list_civcards( TEMPFILE, 1 );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "cardcost" ) )
			{
				list_civcards( TEMPFILE, 1 );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "civcards" ) )
			{
				list_civcards( TEMPFILE, 1 );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "ast" ) )
			{
				list_ast( 1 );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "summary" ) && ( index == 3 ) )
			{
				list_summary( word[ 2 ] );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "all" ) )
			{
				list_cards( 1 );
				list_civcards( TEMPFILE, 1 );
				list_trades( 1 );
				list_proposals( logged_in );
				list_cardcount( 1 );
				list_ast( 1 );
				list_map( NULL, 1 );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "civmap" ) )
			{
				list_civmap();
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "map" ) )
			{
				if( index == 3 )
					list_map( word[ 2 ], 1 );
				else
					list_map( NULL, 1 );
			}
			else if( !strcmp( word[ 0 ], "list" ) &&
				!strcmp( word[ 1 ], "mapinfo" ) )
			{
				list_mapinfo();
			}
			else if( !strcmp( word[ 0 ], "propose" ) )
			{
				if( ( Phase == 5 ) && !PhaseComplete )
				{
					propose = 1;
				}
				else
				{
					fprintf( returnfile, ">>> trading is currently closed\n" );
					zeus_exit( "proposal error" );
				}
			}
			else if( propose == 1 )
			{
				civ = civ_to_num( word[ 0 ] );
				if( civ == -1 )
				{
					fprintf( returnfile,
						">>> \"%s\" is an unknown civilization\n", word[ 0 ] );
					zeus_exit( "proposal error" );
				}
				if( civ != logged_in )
				{
					fprintf( returnfile,
						">>> can't propose a trade for another civilization\n" );
					zeus_exit( "proposal error" );
				}
				if( Civ[ civ ].active != 1 )
				{
					fprintf( returnfile,
						">>> \"%s\" is not an active trading civilization\n",
							Civ[ civ ].abbr );
					zeus_exit( "proposal error" );
				}
				Proposal[ NumProps ].civ1 = civ;
				for( nwrd = 0; nwrd < NTCards; nwrd++ )
				{
					Proposal[ NumProps ].vcard[ nwrd ] = 0;
					Proposal[ NumProps ].ecard[ nwrd ] = 0;
					Proposal[ NumProps ].acard[ nwrd ] = 0;
					Proposal[ NumProps ].scard[ nwrd ] = 0;
				}
				for( nwrd = 1; nwrd < index; nwrd++ )
				{
					card = card_to_num( word[ nwrd ] );
					if( card == -1 )
					{
						fprintf( returnfile,
							">>> \"%s\" is not a valid trade card\n", word[ nwrd ] );
						zeus_exit( "proposal error" );
					}
					if( !Card[ card ].tradeable )
					{
						fprintf( returnfile,
							">>> \"%s\" is a non-tradable calamity\n", word[ nwrd ] );
						zeus_exit( "proposal error" );
					}
					if( !strcmp( Card[ card ].name, "?" ) )
					{
						fprintf( returnfile,
							">>> Illegal use of \"?\" as a trade card\n" );
						zeus_exit( "proposal error" );
					}
					if( ( nwrd == 1 ) || ( nwrd == 2 ) )
						Proposal[ NumProps ].vcard[ card ]++;
					else
						Proposal[ NumProps ].scard[ card ]++;
					Proposal[ NumProps ].acard[ card ]++;
				}
				Proposal[ NumProps ].nsend = index - 1;
				if( Proposal[ NumProps ].nsend < 3 )
				{
					fprintf( returnfile,
						">>> must trade at least three cards\n" );
					zeus_exit( "proposal error" );
				}
				propose = 2;
			}
			else if( propose == 2 )
			{
				civ = civ_to_num( word[ 0 ] );
				if( civ == -1 )
				{
					fprintf( returnfile,
						">>> \"%s\" is an unknown civilization\n", word[ 0 ] );
					zeus_exit( "proposal error" );
				}
				if( civ == logged_in )
				{
					fprintf( returnfile,
						">>> can't trade with yourself\n" );
					zeus_exit( "proposal error" );
				}
				if( Civ[ civ ].active != 1 )
				{
					fprintf( returnfile,
						">>> \"%s\" is not an active trading civilization\n",
							Civ[ civ ].abbr );
					zeus_exit( "proposal error" );
				}
				Proposal[ NumProps ].civ2 = civ;
				for( nwrd = 1; nwrd < index; nwrd++ )
				{
					card = card_to_num( word[ nwrd ] );
					if( card == -1 )
					{
						fprintf( returnfile,
							">>> \"%s\" is not a valid trade card\n", word[ nwrd ] );
						zeus_exit( "proposal error" );
					}
					if( !Card[ card ].tradeable )
					{
						fprintf( returnfile,
							">>> \"%s\" is a non-tradable calamity\n", word[ nwrd ] );
						zeus_exit( "proposal error" );
					}
					if( ( nwrd == 1 ) || ( nwrd == 2 ) )
					{
						if( !strcmp( Card[ card ].name, "?" ) )
						{
							fprintf( returnfile,
								">>> Illegal use of \"?\" as a trade card\n" );
							zeus_exit( "proposal error" );
						}
						Proposal[ NumProps ].ecard[ card ]++;
					}
				}
				Proposal[ NumProps ].nget = index - 1;
				if( Proposal[ NumProps ].nget < 3 )
				{
					fprintf( returnfile,
						">>> must expect at least three cards\n" );
					zeus_exit( "proposal error" );
				}
				Proposal[ NumProps ].complete = 0;
				NumProps++;
				do_trade();
				write_proposals( 0, logged_in );
				list_proposals( logged_in );
				list_proposals( civ );
				propose = 0;
			}
			else
			{
				fprintf( returnfile, ">>> syntax error\n" );
				zeus_exit( "syntax error" );
			}
		}
		if( !mail )
			printf( "<mail> " );
	}
	if( signed_on == 0 )
	{
		fprintf( returnfile, ">>> no signon command given\n" );
		zeus_exit( "signon error" );
	}
	if( mail )
		fprintf( maillog, "*** END MESSAGE ***\n" );
}

open_return_file()
{
	if( mail )
	{
		if( !( returnfile = fopen( RETURNFILE, "w+" ) ) )
		{
			perror( RETURNFILE );
			exit( 1 );
		}
	}
	else
		returnfile = stdout;
}

send_file( filename, title, sender )
char filename[ 128 ];
char *title;
char *sender;
{
	char command[ 128 ];
	if( mail )
	{
		sprintf( command,
			"cat %s | Mail -s \"zeus: %s\" %s", filename, title, sender );
		system( command );

		/* log outgoing mail */
		fprintf( maillog, "( %s )\n", command );
	}
	else
	{
		sprintf( command, "cat %s", filename );
		system( command );
	}
}

send_return_file( title )
char *title;
{
	fclose( returnfile );
	send_file( RETURNFILE, title, sender );
}

zeus_exit( title )
char *title;
{
	if( mail )
	{
		send_return_file( title );
		fprintf( maillog, "*** END MESSAGE ***\n" );
	}
	exit( 0 );
}

fopen_error( filename )
char *filename;
{
	fprintf( returnfile, ">>> could not open file \"%s\"\n", filename );
	zeus_exit( "program error" );
}

help()
{
	send_file( HELPFILE, "help", sender );
}

list_credits()
{
	send_file( CREDITSFILE, "credits chart", sender );
}

list_calamities()
{
	send_file( CALFILE, "calamity effects", sender );
}

list_summary( name )
char *name;
{
	FILE *sumfile;
	char filename[ 128 ];
	char command[ 128 ];

	sprintf( filename, "../sums/%s+", name );
	if( ( sumfile = fopen( filename, "r" ) ) )
	{
		fclose( sumfile );
		sprintf( command,
			"cat %s | Mail -s \"zeus: summary %s\" %s",
			filename, name, sender );
		system( command );
		return;
	}
	sprintf( filename, "../sums/%s", name );
	if( ( sumfile = fopen( filename, "r" ) ) )
	{
		fclose( sumfile );
		sprintf( command,
			"cat %s | Mail -s \"zeus: summary %s\" %s",
			filename, name, sender );
		system( command );
		return;
	}
	fopen_error( filename );
}

list_rules()
{
	send_file( RULESFILE, "rules", sender );
}

list_civmap()
{
	send_file( MAPFILE, "civmap", sender );
}

list_mapinfo()
{
	char command[ 128 ];
	int phase;

	phase = Phase;

	sprintf( command,
		"cat %s | Mail -s \"zeus: mapinfo %d.%d\" %s",
			MAPBOARDINFO, Turn, phase, sender );
	system( command );
}

list_map( phasename, mode )
char *phasename;
int mode;
{
	char command[ 128 ];
	int phase;
	int nphases;
	int index;
	int phasecomplete;

	nphases = 1;
	/* Allow looking at movement map */
	if( Phase == 2 )
		phasecomplete = 1;
	else if( Phase == 5 )
		phasecomplete = 1;
	else
		phasecomplete = PhaseComplete;
	if( phasename == NULL )
	{
		phase = Phase - 1 + phasecomplete;
	}
	else
	{
		if( !strcmp( phasename, "all" ) )
		{
			nphases  = Phase + phasecomplete;
			phase = 0;
		}
		else
		{
			/*
			phase = phase_to_num( phasename ) - 1 + phasecomplete;
			*/
			phase = phase_to_num( phasename );
			if( phase < Phase )
				phase = phase;
			else
				phase = phase - 1 + phasecomplete;
			if( phase == -1 )
			{
				fprintf( returnfile, ">>> syntax error\n" );
				zeus_exit( "syntax error" );
			}
			if( phase > Phase )
			{
				fprintf( returnfile, ">>> phase not active\n" );
				zeus_exit( "phase not active" );
			}
		}
	}

	for( index = 0; index < nphases; index++ )
	{
		if( mode == 1 )
		{
			if( phase == 0 )
				sprintf( command,
					"cat %s | Mail -s \"zeus: map %d.%d\" %s",
					MAPBOARDFILE, Turn, phase, sender );
			else
				sprintf( command,
					"cat %d/mapboard.%d | Mail -s \"zeus: map %d.%d\" %s",
					Turn, phase - 1, Turn, phase, sender );
		}
		else
		{
			if( phase == 0 )
				sprintf( command, "cat %s >> %s", MAPBOARDFILE, TEMPFILE );
			else
				sprintf( command, "cat %d/mapboard.%d >> %s",
					Turn, phase - 1, TEMPFILE );
		}
		system( command );
		phase++;
	}
}

get_passwords()
{
	FILE *passfile;
	char line[ 128 ];
	char *word[ 65 ];
	int index, civ;

	if( !( passfile = fopen( PASSWORDSFILE, "r" ) ) )
		fopen_error( PASSWORDSFILE );

	while( fgetline( passfile, line, 128 ) != -1 )
	{
		index = 0;
		word[ index++ ] = strtok( line, " -:," );
		while( ( word[ index ] = strtok( NULL, " -:," ) ) ) index++;
		strcpy( Civ[ civ_to_num( word[ 0 ] ) ].password, word[ 1 ] );
	}
	fclose( passfile );
}
