
#include "zeus.h"

init_seed()
{
	struct timeval tv;
	struct timezone tz;
	FILE *fileptr;

	gettimeofday( &tv, &tz );
	Seed = 1000000 * tv.tv_sec + tv.tv_usec;

	if( !( fileptr= fopen( SEEDFILE, "w+" ) ) )
		fopen_error( SEEDFILE );
	fprintf( fileptr, "%d\n", Seed );
	fclose( fileptr );
}

init_generator()
{
	struct timeval tv;
	struct timezone tz;
	FILE *fileptr;
	char line[ 128 ];

	if( !( fileptr= fopen( SEEDFILE, "r" ) ) )
	{
		gettimeofday( &tv, &tz );
		Seed = 1000000 * tv.tv_sec + tv.tv_usec;
	
		if( !( fileptr= fopen( SEEDFILE, "w+" ) ) )
			fopen_error( SEEDFILE );
		fprintf( fileptr, "%d\n", Seed );
		fclose( fileptr );
	}
	else
	{
		fgetline( fileptr, line, 128 );
		Seed = atoi( line );
		fclose( fileptr );
	}

	srand( Seed );
}

get_numbers( range, numbers )
int range;
int numbers[ MAX_AREAS ];
{
	int temp;
	int nnum;
	int index;

	for( nnum = 0; nnum < range; nnum++ )
		numbers[ nnum ] = -1;

	nnum = 0;
	while( nnum < range )
	{
		temp = ( rand() * range / RAND_MAX );
		for( index = 0; index < nnum; index++ )
		{
			if( numbers[ index ] == temp )
				break;
		}
		if( temp != numbers[ index ] )
		{
			numbers[ nnum++ ] = temp;
		}
	}
}

int
getline( s, lim )
char s[];
int lim;
{
	int c, i;

	for( i = 0; i < lim - 1 && ( c = getchar() ) != EOF && c != '\n'; ++i )
		s[ i ] = c;
	if( c =='\n' )
		s[ i ] = '\0';

	if( c == EOF )
		return -1;
	else
		return i;
}

int
fgetline( fp, s, lim )
FILE *fp;
char s[];
int lim;
{
	int c, i;

	for( i = 0; i < lim - 1 && ( c = getc(fp) ) != EOF && c != '\n'; ++i )
		s[ i ] = c;
	if( c =='\n' )
		s[ i ] = '\0';

	if( c == EOF )
		return -1;
	else
		return i;
}

char *civturn( filename, civname )
char *filename;
char *civname;
{
	char tmpstring[ 128 ];
	static char *retstring = NULL;

	sprintf( tmpstring, "%d/%s.%s", Turn, filename, civname );

	if( retstring )
		free( retstring );
	retstring = malloc( strlen( tmpstring ) + 1 );
	strcpy( retstring, tmpstring );

	return( retstring );
}

char *turn( filename )
char *filename;
{
	char tmpstring[ 128 ];
	static char *retstring = NULL;

	sprintf( tmpstring, "%d/%s", Turn, filename );

	if( retstring )
		free( retstring );
	retstring = malloc( strlen( tmpstring ) + 1 );
	strcpy( retstring, tmpstring );

	return( retstring );
}
