
#include "zeus.h"

create_trades_file( trn )
int trn;
{
	FILE *tradefile;

	if( !( tradefile = fopen( TRADESFILE, "w" ) ) )
		fopen_error( TRADESFILE );
	fprintf( tradefile,
"Turn %2d - Trade Summary                                         #%2d03\n",
		trn, trn );
	fprintf( tradefile, "=======================\n\n" );
	fclose( tradefile );
}

cancel_proposal( proposal )
char *proposal;
{
	int number, prop;

	number = 0;
	for( prop = 0; prop < NumProps; prop++ )
	{
		if( ( Proposal[ prop ].civ1 == logged_in ) &&
			!Proposal[ prop ].complete )
		{
			number++;
			if( number == atoi( proposal ) )
			{
				Proposal[ prop ].complete = 1;
				write_proposals( 0, logged_in );
				break;
			}
		}
	}
}

list_proposals( civ )
int civ;
{
	write_proposals( 1, civ );

	if( civ == logged_in )
		send_file( TEMPFILE, "proposals", sender );
	else
		send_file( TEMPFILE, "proposals", Civ[ civ ].name );
}

get_proposals()
{
	FILE *propfile;
	char line[ 128 ];
	char *word[ 65 ];
	int nline;
	int index;
	int card;
	int nwrd;
	int propose;

	if( !( propfile = fopen( PROPOSALSFILE, "r" ) ) )
		return;

	nline = 0;
	propose = 0;
	while( fgetline( propfile, line, 128 ) != -1 )
	{
		nline++;

		index = 0;
		word[ index++ ] = strtok( line, " -:," );
		while( ( word[ index ] = strtok( NULL, " -:," ) ) ) index++;

		if( !word[ 0 ] )
			continue;

		if( !strcmp( word[ 0 ], "proposal" ) )
			propose = 1;
		else if( propose == 1 )
		{
			Proposal[ NumProps ].civ1 = civ_to_num( word[ 0 ] );
			for( nwrd = 1; nwrd < index; nwrd++ )
			{
				card = card_to_num( word[ nwrd ] );
				if( ( nwrd == 1 ) || ( nwrd == 2 ) )
					Proposal[ NumProps ].vcard[ card ]++;
				else
					Proposal[ NumProps ].scard[ card ]++;
				Proposal[ NumProps ].acard[ card ]++;
			}
			Proposal[ NumProps ].nsend = index - 1;
			propose = 2;
		}
		else if( propose == 2 )
		{
			Proposal[ NumProps ].civ2 = civ_to_num( word[ 0 ] );
			for( nwrd = 1; nwrd < index; nwrd++ )
			{
				card = card_to_num( word[ nwrd ] );
				if( ( nwrd == 1 ) || ( nwrd == 2 ) )
					Proposal[ NumProps ].ecard[ card ]++;
			}
			Proposal[ NumProps ].nget = index - 1;
			Proposal[ NumProps ].complete = 0;
			NumProps++;
			propose = 0;
		}
	}
	fclose( propfile );
}

int cards_in_hand( prop )
int prop;
{
	int civ, index;

	civ = Proposal[ prop ].civ1;
	for( index = 0; index < NTCards; index++ )
	{
		if( Civ[ civ ].cards[ index ] < Proposal[ prop ].acard[ index ] )
			return( 0 );
	}
	return( 1 );
}

do_trade()
{
	FILE *tradefile, *cardfile;
	char filename[ 128 ];
	char command[ 128 ];
	char title[ 128 ];
	int card;
	int prop1, prop2;
	int civ, index;
	int civa, civb;
	int match;

	for( civ = 0; civ < NumCivs; civ++ )
		if( Civ[ civ ].active == 1 )
			get_hand( civ, 0 );

	for( prop1 = 0; prop1 < NumProps; prop1++ )
	{
		for( prop2 = 0; prop2 < NumProps; prop2++ )
		{
			match = 0;
			if( !Proposal[ prop1 ].complete &&
				( Proposal[ prop1 ].civ1 == Proposal[ prop2 ].civ2 ) &&
				( Proposal[ prop1 ].civ2 == Proposal[ prop2 ].civ1 ) &&
				( Proposal[ prop1 ].nsend == Proposal[ prop2 ].nget ) &&
				( Proposal[ prop1 ].nget == Proposal[ prop2 ].nsend ) &&
				cards_in_hand( prop1 ) && cards_in_hand( prop2 ) )
			{
				for( index = 0; index < NTCards; index++ )
				{
					if( ( Proposal[ prop1 ].ecard[ index ] <=
						Proposal[ prop2 ].vcard[ index ] ) &&
						( Proposal[ prop2 ].ecard[ index ] <=
						Proposal[ prop1 ].vcard[ index ] ) )
					{
						if( Proposal[ prop1 ].ecard[ index ] == 1 )
							match += 1;
						else if( Proposal[ prop1 ].ecard[ index ] == 2 )
							match += 2;
						if( Proposal[ prop2 ].ecard[ index ] == 1 )
							match += 1;
						else if( Proposal[ prop2 ].ecard[ index ] == 2 )
							match += 2;
					}
				}
			}
			if( match == 4 )
			{
				Proposal[ prop1 ].complete = 1;
				Proposal[ prop2 ].complete = 1;

				civa = Proposal[ prop1 ].civ1;
				civb = Proposal[ prop2 ].civ1;

				for( index = 0; index < NTCards; index++ )
				{
					Civ[ civa ].cards[ index ] +=
						Proposal[ prop2 ].acard[ index ];
					Civ[ civa ].cards[ index ] -=
						Proposal[ prop1 ].acard[ index ];
					Civ[ civb ].cards[ index ] +=
						Proposal[ prop1 ].acard[ index ];
					Civ[ civb ].cards[ index ] -=
						Proposal[ prop2 ].acard[ index ];
				}

				if( !( tradefile = fopen( TRADESFILE, "a" ) ) )
					fopen_error( TRADESFILE );

				fprintf( tradefile, "%s:",Civ[ civa ].abbr );

				for( index = 0; index < NTCards; index++ )
					if( Proposal[ prop1 ].vcard[ index ] == 1 )
						fprintf( tradefile, "%4s",Card[ index ].abbr );
					else if( Proposal[ prop1 ].vcard[ index ] == 2 )
						fprintf( tradefile, "%4s%4s",
							Card[ index ].abbr, Card[ index ].abbr );

				for( index = 2; index < Proposal[ prop1 ].nsend; index++ )
					fprintf( tradefile, "%2s", "?" );

				fprintf( tradefile, "\n" );
				fprintf( tradefile, "%s:",Civ[ civb ].abbr );

				for( index = 0; index < NTCards; index++ )
					if( Proposal[ prop1 ].ecard[ index ] == 1 )
						fprintf( tradefile, "%4s",Card[ index ].abbr );
					else if( Proposal[ prop1 ].ecard[ index ] == 2 )
						fprintf( tradefile, "%4s%4s",
							Card[ index ].abbr, Card[ index ].abbr );

				for( index = 2; index < Proposal[ prop2 ].nsend; index++ )
					fprintf( tradefile, "%2s", "?" );

				fprintf( tradefile, "\n" );
				fprintf( tradefile, "---\n" );
				fclose( tradefile );

				/*
				send_file( TRADESFILE, "trades", "aciv" );
				*/
				for( civ = 0; civ < NumCivs; civ++ )
					if( Civ[ civ ].active == 1 )
						send_file( TRADESFILE, "trades", Civ[ civ ].name );

				if( !( cardfile = fopen( CARDSFILE( Civ[ civa ].abbr ), "a" ) ) )
					fopen_error( CARDSFILE( Civ[ civa ].abbr ) );

				fprintf( cardfile, "trd-%s: ", Civ[ civb ].abbr );

				for( index = 0; index < NTCards; index++ )
					if( Proposal[ prop2 ].acard[ index ] == 1 )
						fprintf( cardfile, "%3s ", Card[ index ].abbr );
					else if( Proposal[ prop2 ].acard[ index ] > 1 )
						fprintf( cardfile, "%1d-%3s ",
							Proposal[ prop2 ].acard[ index ],
							Card[ index ].abbr );

				fprintf( cardfile, "<> " );

				for( index = 0; index < NTCards; index++ )
					if( Proposal[ prop1 ].acard[ index ] == 1 )
						fprintf( cardfile, "%3s ", Card[ index ].abbr );
					else if( Proposal[ prop1 ].acard[ index ] > 1 )
						fprintf( cardfile, "%1d-%3s ",
							Proposal[ prop1 ].acard[ index ],
							Card[ index ].abbr );

				fprintf( cardfile, "\n" );
				fprintf( cardfile, "hnd: " );

				for( index = 0; index < NTCards; index++ )
					if( Civ[ civa ].cards[ index ] == 1 )
						fprintf( cardfile, "%3s ", Card[ index ].abbr );
					else if( Civ[ civa ].cards[ index ] > 1 )
						fprintf( cardfile, "%1d-%3s ",
							Civ[ civa ].cards[ index ],
							Card[ index ].abbr );

				fprintf( cardfile, "\n" );

				fprintf( cardfile, "--- %d\n", total_in_hand( civa ) );

				fclose( cardfile );

				sprintf( title, "%s's cards", Civ[ civa ].name );
				send_file( CARDSFILE( Civ[ civa ].abbr ), title,
					Civ[ civa ].name );

				if( !( cardfile = fopen( CARDSFILE( Civ[ civb ].abbr ), "a" ) ) )
					fopen_error( CARDSFILE( Civ[ civb ].abbr ) );

				fprintf( cardfile, "trd-%s: ", Civ[ civa ].abbr );

				for( index = 0; index < NTCards; index++ )
					if( Proposal[ prop1 ].acard[ index ] == 1 )
						fprintf( cardfile, "%3s ", Card[ index ].abbr );
					else if( Proposal[ prop1 ].acard[ index ] > 1 )
						fprintf( cardfile, "%1d-%3s ",
							Proposal[ prop1 ].acard[ index ],
							Card[ index ].abbr );

				fprintf( cardfile, "<> " );

				for( index = 0; index < NTCards; index++ )
					if( Proposal[ prop2 ].acard[ index ] == 1 )
						fprintf( cardfile, "%3s ", Card[ index ].abbr );
					else if( Proposal[ prop2 ].acard[ index ] > 1 )
						fprintf( cardfile, "%1d-%3s ",
							Proposal[ prop2 ].acard[ index ],
							Card[ index ].abbr );

				fprintf( cardfile, "\n" );
				fprintf( cardfile, "hnd: " );

				for( index = 0; index < NTCards; index++ )
					if( Civ[ civb ].cards[ index ] == 1 )
						fprintf( cardfile, "%3s ", Card[ index ].abbr );
					else if( Civ[ civb ].cards[ index ] > 1 )
						fprintf( cardfile, "%1d-%3s ",
							Civ[ civb ].cards[ index ],
							Card[ index ].abbr );

				fprintf( cardfile, "\n" );

				fprintf( cardfile, "--- %d\n", total_in_hand( civb ) );

				fclose( cardfile );

				sprintf( title, "%s's cards", Civ[ civb ].name );
				send_file( CARDSFILE( Civ[ civb ].abbr ), title,
					Civ[ civb ].name );

				prop1 = -1; /* start from the beginning again */

				break;
			} /* end match */
		} /* end prop2 for loop */
	} /* end prop1 for loop */
}

write_proposals( mode, civ )
int mode;
int civ;
{
	FILE *propfile;
	int prop, index, card, number;
	int proposals_exist = 0;

	if( mode == 0 )
	{
		if( !( propfile = fopen( PROPOSALSFILE, "w+" ) ) )
			fopen_error( PROPOSALSFILE );
	}
	else if( mode == 1 )
	{
		if( !( propfile = fopen( TEMPFILE, "w+" ) ) )
			fopen_error( TEMPFILE );
	}
	else if( mode == 2 )
	{
		if( !( propfile = fopen( TEMPFILE, "a" ) ) )
			fopen_error( TEMPFILE );
	}

	if( mode )
	{
		fprintf( propfile, "List of Proposals\n" );
		fprintf( propfile, "=================\n\n" );
	}

	number = 0;
	for( prop = 0; prop < NumProps; prop++ )
	{
		if( Proposal[ prop ].complete )
			continue;

		if( ( mode ) &&
			( Proposal[ prop ].civ1 != civ ) &&
			( Proposal[ prop ].civ2 != civ ) )
			continue;

		if( ( mode ) && ( Proposal[ prop ].civ1 == civ ) )
		{
			number++;
			fprintf( propfile, "\nproposal %d - %s\n",
				number, Civ[ Proposal[ prop ].civ1 ].name );
			proposals_exist = 1;
		}
		else
		{
			fprintf( propfile, "\nproposal - %s\n",
				Civ[ Proposal[ prop ].civ1 ].name );
			proposals_exist = 1;
		}

		fprintf( propfile, "%s:", Civ[ Proposal[ prop ].civ1 ].abbr );

		for( index = 0; index < NTCards; index++ )
			for( card = 0; card < Proposal[ prop ].vcard[ index ]; card++ )
				fprintf( propfile, "%4s", Card[ index ].abbr );

		if( ( mode ) && ( Proposal[ prop ].civ1 != civ ) )
			for( index = 2; index < Proposal[ prop ].nsend; index++ )
				fprintf( propfile, "%2s", "?" );
		else
			for( index = 0; index < NTCards; index++ )
				for( card = 0; card < Proposal[ prop ].scard[ index ]; card++ )
					fprintf( propfile, "%4s", Card[ index ].abbr );

		fprintf( propfile, "\n" );

		fprintf( propfile, "%s:", Civ[ Proposal[ prop ].civ2 ].abbr );

		for( index = 0; index < NTCards; index++ )
			for( card = 0; card < Proposal[ prop ].ecard[ index ]; card++ )
				fprintf( propfile, "%4s", Card[ index ].abbr );

		for( index = 2; index < Proposal[ prop ].nget; index++ )
			fprintf( propfile, "%2s", "?" );

		fprintf( propfile, "\n" );
	}

	if( mode && !proposals_exist )
		fprintf( propfile, "There are currently no proposals involving you\n" );

	fclose( propfile );
}

list_trades( mode )
int mode;
{
	char command[ 128 ];

	if( mode )
	{
		send_file( TRADESFILE, "trades", sender );
	}
	else
	{
		sprintf( command, "cat %s >> %s", TRADESFILE, TEMPFILE );
		system( command );
	}
}
