
#include "zeus.h"

int phase_to_num( name )
char *name;
{
	int phase;
	for( phase = 0; phase < NUM_PHASES; phase++ )
		if( !strcasecmp( PhaseName[ phase ], name ) )
			return( phase );
	return( -1 );
}

handle_nextphase()
{
	FILE *fileptr;
	fileptr = fopen( PHASEFILE, "w+" );
	if( !fileptr )
		fopen_error( PHASEFILE );
	Phase++;
	PhaseComplete = 0;
	fprintf( fileptr, "%d %d\n", Phase, PhaseComplete );
	fclose( fileptr );
}

handle_endphase()
{
	FILE *fileptr;
	fileptr = fopen( PHASEFILE, "w+" );
	if( !fileptr )
		fopen_error( PHASEFILE );
	PhaseComplete = 1;
	fprintf( fileptr, "%d %d\n", Phase, PhaseComplete );
	fclose( fileptr );
}

get_turn()
{
	char line[ 128 ];
	FILE *fileptr;
	char *word[ 65 ];
	int index;

	fileptr = fopen( TURNFILE, "r" );
	if( !fileptr )
		fopen_error( TURNFILE );

	fgetline( fileptr, line, 128 );
	Turn = atoi( line );
	fclose( fileptr );

	fileptr = fopen( PHASEFILE, "r" );
	if( !fileptr )
		fopen_error( PHASEFILE );

	fgetline( fileptr, line, 128 );

	index = 0;
	word[ index++ ] = strtok( line, " :,-" );
	while( ( word[ index ] = strtok( NULL, " :,-" ) ) ) index++;

	Phase = atoi( word[ 0 ] );
	PhaseComplete = atoi( word[ 1 ] );
	fclose( fileptr );

	fileptr = fopen( STARTTIMEFILE, "r" );
	if( !fileptr )
		fopen_error( STARTTIMEFILE );

	fgetline( fileptr, line, 128 );
	starttime = atoi( line );
	fclose( fileptr );
}

handle_newturn()
{
	FILE *fileptr;
	char command[ 128 ];
	int newturn, civ;

	newturn = Turn + 1;

	sprintf( command, "mkdir %d", newturn );
	system( command );
	sprintf( command, "/bin/cp %d/techs.1 %d/techs", Turn, newturn );
	system( command );
	sprintf( command, "/bin/cp %d/ast.1 %d/ast", Turn, newturn );
	system( command );
	sprintf( command, "/bin/cp %d/AST.1 %d/AST", Turn, newturn );
	system( command );
	sprintf( command, "/bin/cp %d/decks.2 %d/decks", Turn, newturn );
	system( command );

	sprintf( command, "/bin/cp %d/calloc.2 %d/calloc", Turn, newturn );
	system( command );

	sprintf( command,
		"cat %d/mapboard.6 | sed s/Turn:%d/Turn:%d/ > %d/mapboard",
		Turn, Turn, newturn, newturn );
	system( command );
	sprintf( command, "/bin/rm TURN" );
	system( command );
	sprintf( command, "echo %d > TURN", newturn );
	system( command );
	sprintf( command, "/bin/rm PHASE" );
	system( command );
	sprintf( command, "echo 1 0 > PHASE" );
	system( command );
	for( civ = 0; civ < NumCivs; civ++ )
	{
		if( Civ[ civ ].active )
		{
			sprintf( command, "/bin/cp %d/CARDS.%s %d/cards.%s",
				Turn, Civ[ civ ].abbr, newturn, Civ[ civ ].abbr );
			system( command );
		}
	}

	Turn = newturn;
	Phase = 1;
	PhaseComplete = 0;

	/* get new turn info */
	get_turn_info();
	get_mapboard();
	get_census_order();

	/* create orders files */
	init_order_file( SHIPSFILE, 0 );
	init_order_file( MOVESFILE, 1 );
	init_order_file( PILLAGEFILE, 0 );
	init_order_file( NEWCITIESFILE, 0 );
	init_order_file( GROWTHFILE, 0 );
	init_order_file( PURCHASESFILE, 0 );
	init_order_file( GOLDFILE, 0 );
	init_order_file( LISTSFILE, 2 );
	sprintf( command, "/bin/touch %d/ord.cala", Turn );
	system( command );
	create_trades_file( Turn );

	init_seed();
}

get_turn_info()
{
	int civ;

	/* read current ast positions and proposals */
	get_ast_positions();
	get_proposals();

	/* read current civ card holdings */
	get_techs();

	/* read each player's trade card holdings */
	for( civ = 0; civ < NumCivs; civ++ )
		get_hand( civ, 1 );

	/* read the current deck situation */
	if( mail )
		get_decks( 1 );
	else
		get_decks( 0 );

	/* init the random number generator */
	init_generator();
}
