
#define  MAIN
#include "zeus.h"

get_params()
{
	FILE *fileptr;
	FILE *mapfile;
	char line[ 128 ], buffer[ 128 ];
	char *word[ 65 ];
	int index;
	int area;

	if( !( fileptr= fopen( PARAMSFILE, "r" ) ) )
		return;
	while( fgetline( fileptr, line, 128 ) != -1 )
	{
		index = 0;
		word[ index++ ] = strtok( line, " -:," );
		while( ( word[ index ] = strtok( NULL, " -:," ) ) ) index++;

		if( !strcasecmp( word[ 0 ], "maxtokens" ) )
		{
			MaxTokens = atoi( word[ 1 ] );
		}
		else if( !strcasecmp( word[ 0 ], "maxcities" ) )
		{
			MaxCities = atoi( word[ 1 ] );
		}
		else if( !strcasecmp( word[ 0 ], "showcalamities" ) )
		{
			if( !strcasecmp( word[ 1 ], "true" ) )
			{
				ShowCalamities = 1;
			}
			else if( !strcasecmp( word[ 1 ], "false" ) )
			{
				ShowCalamities = 0;
			}
		}
		/*
		else if( !strcasecmp( word[ 0 ], "inactivemap" ) )
		{
			if( ( mapfile = fopen( word[ 1 ], "r" ) ) )
			{
				while( fgetline( mapfile, buffer, 128 ) != -1 )
				{
					area = area_to_num( buffer );
					if( area != -1 )
						Map[ area ].active = 0;
				}
				fclose( mapfile );
			}
			else
			{
				fprintf( returnfile, ">>> bad map file %s\n", word[ 1 ] );
				zeus_exit( "map error" );
			}
		}
		*/
		else if( !strcasecmp( word[ 0 ], "activemap" ) )
		{
			if( ( mapfile = fopen( word[ 1 ], "r" ) ) )
			{
				while( fgetline( mapfile, buffer, 128 ) != -1 )
				{
					area = area_to_num( buffer );
					if( area != -1 )
						Map[ area ].active = 1;
				}
				fclose( mapfile );
			}
			else
			{
				fprintf( returnfile, ">>> bad map file %s\n", word[ 1 ] );
				zeus_exit( "map error" );
			}
		}
	}
	fclose( fileptr );
}

init_game()
{
	FILE *fileptr;
	char line[ 128 ];
	char command[ 128 ];
	int civ;
	int num_players = 0;

	Turn = 1;
	Phase = 1;
	PhaseComplete = 0;

	printf( "\ncreate new game (y or n)? " );
	getline( line, 128 );
	if( strcmp( line, "y" ) )
		exit( 0 );

	printf( "\nnumber of players? " );
	getline( line, 128 );
	num_players = atoi( &line[ 0 ] );
	if( num_players == 0 )
		exit( 1 );

	printf( "\nGame Parameters:\n\n" );
	system( "cat world/PARAMS" );

	printf( "\nuse these parameters (y or n)? " );
	getline( line, 128 );
	if( strcmp( line, "y" ) )
	{
		printf( "\nplease edit the file \"world/PARAMS\"\n\n" );
		exit( 0 );
	}
	
	printf( "\nreading \"START\" file...\n" );
	fileptr = fopen( STARTFILE, "r" );
	if( !fileptr )
	{
		printf( "\nyou must create a file called \"START\" which contains\n" );
		printf( "one \"addplayer\" command for each player of the form:\n" );
		printf( "    addplayer <civilization> <start_area> <player_name>\n\n" );
		exit( 1 );
	}
	modify_mapboard( fileptr, stdout );
	fclose( fileptr );

	if( num_players != NumPlayers )
	{
		printf( "%d player(s) have selected civilizations\n", NumPlayers );
		exit( 1 );
	}

	printf( "\nall players have selected civilizations\n" );

	printf( "\ncreating game files...\n" );

	unlink( CIVSFILE );
	fileptr = fopen( CIVSFILE, "w" );
	if( !fileptr )
		fopen_error( CIVSFILE );
	for( civ = 0; civ < NumCivs; civ++ )
		fprintf( fileptr, "%-12s %3s %d %s\n", Civ[ civ ].name,
			Civ[ civ ].abbr, Civ[ civ ].active, Civ[ civ ].player );
	fclose( fileptr );

	unlink( PASSWORDSFILE );
	fileptr = fopen( PASSWORDSFILE, "w" );
	if( !fileptr )
		fopen_error( PASSWORDSFILE );
	for( civ = 0; civ < NumCivs; civ++ )
		if( Civ[ civ ].active )
			fprintf( fileptr, "%3s %s\n", Civ[ civ ].abbr, "password" );
	fclose( fileptr );

	sprintf( command, "/bin/rm -fr 1 PHASE TURN" );
	system( command );

	fileptr = fopen( TURNFILE, "w" );
	if( !fileptr )
		fopen_error( TURNFILE );
	fprintf( fileptr, "%d\n", Turn );
	fclose( fileptr );

	fileptr = fopen( PHASEFILE, "w" );
	if( !fileptr )
		fopen_error( PHASEFILE );
	fprintf( fileptr, "%d %d\n", Phase, PhaseComplete );
	fclose( fileptr );

	mkdir( "1", 00777 );

	fileptr = fopen( TECHSFILE, "w" );
	if( !fileptr )
		fopen_error( TECHSFILE );
	for( civ = 0; civ < NumCivs; civ++ )
		if( Civ[ civ ].active )
			fprintf( fileptr, "%s:\n", Civ[ civ ].abbr );
	fclose( fileptr );

	fileptr = fopen( ASTPOSFILE, "w" );
	if( !fileptr )
		fopen_error( ASTPOSFILE );
	for( civ = 0; civ < NumCivs; civ++ )
		if( Civ[ civ ].active )
			fprintf( fileptr, "%s: %d\n", Civ[ civ ].abbr, Civ[ civ ].astpos );
	fclose( fileptr );

	create_AST_file( ASTFILE, 0 );

	fileptr = fopen( DECKSFILE, "w" );
	if( !fileptr )
		fopen_error( DECKSFILE );
	init_decks( fileptr );
	fclose( fileptr );

	fileptr = fopen( MAPBOARDFILE, "w" );
	if( !fileptr )
		fopen_error( MAPBOARDFILE );
	print_mapboard( fileptr, -1, 0 );
	fclose( fileptr );

	for( civ = 0; civ < NumCivs; civ++ )
		if( Civ[ civ ].active )
		{
			if( !( fileptr = fopen( CARDSFILE( Civ[ civ ].abbr ), "w" ) ) )
				fopen_error( CARDSFILE( Civ[ civ ].abbr ) );
			fprintf( fileptr, "Trade Cards - %-7s\n", Civ[ civ ].name );
			fprintf( fileptr, "=====================\n\n" );
			fprintf( fileptr, "=========\n" );
			fprintf( fileptr, " Turn %-2d\n", Turn );
			fprintf( fileptr, "=========\n" );
			fprintf( fileptr, "hnd:" );
			fprintf( fileptr, "\n" );
			fprintf( fileptr, "---\n" );
			fclose( fileptr );
		}

	/* get new turn info */
	get_turn_info();
	get_mapboard();
	get_census_order();

	create_calamity_locations_file();

	/* create orders files */
	init_order_file( SHIPSFILE, 0 );
	init_order_file( MOVESFILE, 1 );
	init_order_file( PILLAGEFILE, 0 );
	init_order_file( NEWCITIESFILE, 0 );
	init_order_file( GROWTHFILE, 0 );
	init_order_file( PURCHASESFILE, 0 );
	init_order_file( GOLDFILE, 0 );
	init_order_file( LISTSFILE, 2 );
	sprintf( command, "/bin/touch %d/ord.cala", Turn );
	system( command );

	unlink( STARTTIMEFILE );
	fileptr = fopen( STARTTIMEFILE, "w" );
	if( !fileptr )
		fopen_error( STARTTIMEFILE );
	time( &starttime );
	fprintf( fileptr, "%d", starttime );
	fclose( fileptr );
}

main( argc, argv )
int argc;
char *argv[];
{
	int opt;
	int civ;
	char line[ 128 ];
	extern char *optarg;
	extern int optind;
	FILE *fileptr;

	/* zeus -m is run from the mailer; zeus without options when interactive */

	while( ( opt = getopt( argc, argv, "mt:p:s:n" ) ) != -1 )
	{
		switch( (char) opt )
		{
			case 'm':
				mail = 1;
				break;
			case 't':
				Turn = atoi( optarg );
				break;
			case 'p':
				Phase = atoi( optarg );
				break;
			case 's':
				PhaseComplete = atoi( optarg );
				break;
			case 'n':
				NewGame = 1;
				break;
		}
	}

	fileptr = fopen( TURNFILE, "r" );
	if( !fileptr )
		NewGame = 1;
	else
		fclose( fileptr );

	/* initialize the whole thing */

	/* create a file for sending errors back to the sender */
	open_return_file();

	/* read the civs involved in the game */
	if( NewGame )
		get_civs( CIVSTEMPLATE );
	else
		get_civs( CIVSFILE );

	/* get year information */
	get_years();

	/* read the ast chart information */
	get_ast();

	/* read in the civ map and paths */
	get_map();

	/* get game specific parameters, this MUST be done here */
	get_params();

	/* get paths */
	get_paths();
	verify_paths();

	/* read the trade card information */
	get_cards();

	/* read the civ card information and credits chart */
	get_civcards();
	get_credits();

	/* create new game */
	if( NewGame )
		init_game();
	else if( Turn == -1 )
		get_turn();

	/* get turn specific stuff */
	get_turn_info();

	get_passwords();

	/* mail is set when zeus is run from the mailer daemon */
	if( mail )
	{
		read_mail( stdin );
		exit( 0 );
	}

	/* past here is only for zeus interactive */

	/* read the current mapboard */
	get_mapboard();

	/* print prompt and get commands from moderator */

	printf( "<%s:%d.%d.%d> ", argv[0], Turn, Phase, PhaseComplete );
	while( getline( line, 128 ) != -1 )
	{
		if( !strcmp( line, "mail" ) )
		{
			read_mail( stdin );
		}

		else if( !strcmp( line, "go" ) )
		{
			switch ( Phase )
			{
				case 1:
					handle_ships();
					break;
				case 2:
					handle_move();
					break;
				case 3:
					handle_conflict();
					break;
				case 4:
					handle_cities();
					break;
				case 5:
					handle_deal();
					break;
				case 6:
					handle_calamities();
					break;
				case 7:
					handle_growth();
					break;
			}
			handle_map();
		}

		/* Phase 1 */
		/* requires "ships" file */
		else if( !strcmp( line, "ships" ) )
		{
			handle_ships();
		}

		/* Phase 2 */
		/* requires "moves" file */
		else if( !strcmp( line, "move" ) )
		{
			handle_move();
		}

		/* Phase 3 */
		/* requires "pillage" file */
		else if( !strcmp( line, "conflict" ) )
		{
			handle_conflict();
		}

		/* Phase 4 */
		/* requires "newcities" file */
		else if( !strcmp( line, "cities" ) )
		{
			handle_cities();
		}

		/* Phase 5 */
		/* requires "gold" file */
		else if( !strcmp( line, "deal" ) )
		{
			handle_deal();
		}

		/* Phase 5 */
		/* requires "gold" file */
		/* re-deal trade cards */
		else if( !strcmp( line, "newdeal" ) )
		{
			handle_newdeal();
		}

		/* Phase 6 */
		/* requires "calamities" file */
		else if( !strcmp( line, "calam" ) )
		{
			handle_calamities();
		}

		/* Phase 7 */
		/* requires "growth" file */
		else if( !strcmp( line, "grow" ) )
		{
			handle_growth();
		}

		else if( !strcmp( line, "map" ) )
		{
			handle_map();
		}
		else if( !strcmp( line, "fate" ) )
		{
			handle_fate();
		}
		else if( !strcmp( line, "newturn" ) )
		{
			handle_newturn();
		}
		else if( !strcmp( line, "nextphase" ) )
		{
			handle_nextphase();
		}
		else if( !strcmp( line, "endphase" ) )
		{
			handle_endphase();
		}
		else if( !strcmp( line, "q" ) )
		{
			exit( 0 );
		}
		else if( !strcmp( line, "quit" ) )
		{
			exit( 0 );
		}
		else if( !strcmp( line, "exit" ) )
		{
			exit( 0 );
		}
		else if( !strcmp( line, "help" ) )
		{
			printf("ships move conflict cities deal calam grow\n");
			printf("go newdeal newturn nextphase endphase\n");
			printf("map fate quit exit\n");
		}
		else if( strlen( line ) == 0 )
		{
		}
		else
		{
			printf("Syntax Error\n");
		}

		printf( "<%s:%d.%d.%d> ", argv[0], Turn, Phase, PhaseComplete );
	}
}
